%**************************************************************************
% Filename   : addMaskToMovie.m
% Description: add to each frame the track corresponfing to the movement of
%              the subject in the previous specified k frames.
% Authors    : Marco Branca, Lorenzo Camerini
%**************************************************************************
frameWithKTrack = frames;

colorWaitbar(0, barHandler, 'Adding track to the movie: please wait...');
numFrames = length(frames);

for i = 2:numFrames-1
    track = cast(zeros(size(mask(:,:,i))), 'double');
    
    if i <= k 
        first = 1;        
    else
        first = i-k;
    end
    
    for j = first:i
            temp = cast(track == 0, 'double');
            track = track + ((j-first)/k)*cast(mask(:,:,j),'double').*temp;
    end
    
    track = track.*cast(~separatedBackFore(i).cdata, 'double');
    %((k+i-j)/k)
    %track = track/max(max(track));
    %figure, imshow(track);
    %mean(mean(track))
    %pause;
    
    %computes a matrix composed of all zero, but stores the values needed to
    %have white for pixels corresponding to the track
    
    transparency = 1-track;
    
    imwrite(frameWithKTrack(i).cdata, [mat2str(i) '.png'], 'Alpha', transparency);
    
    
    dissolvedTrackRGB = cast(ones(size(frameWithKTrack(i).cdata)),'double');

    trackBool = cast(track == 0,'double');
    
    for channel = 1:3 
        dissolvedTrackRGB(:,:,channel) = dissolvedTrackRGB(:,:,channel).*trackBool;        
        dissolvedTrackRGB(:,:,channel) = dissolvedTrackRGB(:,:,channel) + track;
    end

    frameWithKTrack(i).cdata = cast(frameWithKTrack(i).cdata,'double');
    %frameWithKTrack(i).cdata = cast(frameWithKTrack(i).cdata,'single').*dissolvedTrackRGB;
    imwrite(cast(frameWithKTrack(i).cdata,'uint8'), [mat2str(i) '.jpg']);
    %adds the track to the current frame
    %frameWithKTrack(i).cdata = frameWithKTrack(i).cdata + trackMatrix; 
    %colorWaitbar(i/numFrames, barHandler);
end

close(barHandler);

