%**************************************************************************
% Filename   : addMaskToMovie.m
% Description: add to each frame the track corresponfing to the movement of
%              the subject in the previous specified k frames.
% Authors    : Marco Branca, Lorenzo Camerini
%**************************************************************************
function transparency = computeLastImageTransparency(mask, separatedBackFore, technique)

maskLen = size(mask,3);
track = cast(zeros(size(mask(:,:,1))), 'double');

for i = 1:maskLen
    temp = cast(track == 0, 'double');
    track = track + ((maskLen-i)/maskLen)*cast(mask(:,:,i),'double').*cast(~separatedBackFore, 'double').*temp;
end

if strcmp(technique, 'envelope2')
    temp = 1 - track;
    %transparency = 1-track;

    dx=[-1 0 1; -1 0 1; -1 0 1];
    dy=dx';

    Ix=conv2(double(temp),dx,'same');
    Iy=conv2(double(temp),dy,'same');
    gradientMagnitude = sqrt(Ix.^2+Iy.^2);


    transparency = 1-edge(gradientMagnitude, 'canny');
else 
    transparency = 1-track;
end