function varargout = myCameraGUI(varargin)
% MYCAMERAGUI M-file for myCameraGUI.fig
%      MYCAMERAGUI, by itself, creates a new MYCAMERAGUI or raises the existing
%      singleton*.
%
%      H = MYCAMERAGUI returns the handle to a new MYCAMERAGUI or the handle to
%      the existing singleton*.
%
%      MYCAMERAGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MYCAMERAGUI.M with the given input arguments.
%
%      MYCAMERAGUI('Property','Value',...) creates a new MYCAMERAGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before myCameraGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to myCameraGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help myCameraGUI

% Last Modified by GUIDE v2.5 18-Feb-2008 12:54:53

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @myCameraGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @myCameraGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before myCameraGUI is made visible.
function myCameraGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to myCameraGUI (see VARARGIN)

% Choose default command line output for myCameraGUI
handles.output = hObject;

% Update handles structure
%handles.lore = 'ciao';
guidata(hObject, handles);
% UIWAIT makes myCameraGUI wait for user response (see UIRESUME)
%uiwait(handles.myCameraGUI);

% --- Outputs from this function are returned to the command line.
function varargout = myCameraGUI_OutputFcn(hObject, eventdata, handles)
% varargout cell array for returning output args (see VARARGOUT);
% hObject handle to figure
% eventdata reserved - to be defined in a future version of MATLAB
% handles structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
handles.output = hObject;
varargout{1} = handles.output;

function VideoName_Callback(hObject, eventdata, handles)
% hObject    handle to VideoName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of VideoName as text
%        str2double(get(hObject,'String')) returns contents of VideoName as a double
NewStr = get(hObject,'String');
handles.VideoName = NewStr;
guidata(hObject, handles);

% --- Executes on button press in openVideo.
function openVideo_Callback(hObject, eventdata, handles)
% hObject    handle to openVideo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%if strcmp(get(handles.openVideo,'String'),'Play Video')
% Camera is off. Change button string and start camera.
%set(handles.openVideo,'String','Stop Video')
try
frames = getFrames(handles.VideoName);
info = aviinfo(handles.VideoName);
set(handles.framesValue,'String',mat2str(info.NumFrames));
set(handles.sizeValue,'String',[mat2str(info.Width) 'x' mat2str(info.Height)]);
movie(handles.cameraAxes, frames, 1, 25);
handles.video = frames;
handles.movieInfo = info;
guidata(hObject, handles);
catch
  disp(lasterr);  
end



% --- Executes on button press in computeStart.
function computeStart_Callback(hObject, eventdata, handles)
% hObject    handle to computeStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
filename = handles.VideoName;
k = handles.trackLenghtValue;
samplingRate = handles.samplingRateValue;
flickeringFactor = handles.flickeringFactorValue;
fromFrame = handles.fromFrameValue; 
toFrame = handles.toFrameValue;

computationType = handles.selectedTechnique;
frames = handles.video(fromFrame:toFrame);

[separatedBackFore, barHandler, colorBackGround] = eraseBackground(frames);

transparencyValue = handles.transparencyValue;
switch computationType
    case 'envelope'
        dilateType = handles.selectedOption;
        switch dilateType
            case 'line'
                data = [handles.lengthLineValue handles.angleLineValue];
            case 'disk'
                data = [handles.radiusDiskValue];
        end
        edges = computeCanny(separatedBackFore, barHandler);
        envelope;
        handles.resultLastFrame = envelopeLastFrame;
    case 'replicationContours'
        edges = computeCanny(separatedBackFore, barHandler);
        replicationOfContours;
        handles.resultLastFrame = replicationOfContoursLastFrame;
    case 'harris'
        edges = computeHarris(separatedBackFore, barHandler);
        replicationOfContours;
        handles.resultLastFrame = replicationOfContoursLastFrame;
end
handles.transparencyMatrix = transparencyMatrix;
handles.resultMovie = frameWithKTrack;
guidata(hObject, handles);
imwrite(handles.resultLastFrame, [handles.VideoName '.png'], 'Alpha', handles.transparencyMatrix,'Background', colorBackGround/255);
set(gcf,'CurrentAxes',handles.cameraAxes);
imshow(imread([handles.VideoName '.png']));

function trackLenghtValue_Callback(hObject, eventdata, handles)
% hObject    handle to trackLenghtValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trackLenghtValue as text
%        str2double(get(hObject,'String')) returns contents of trackLenghtValue as a double
handles.trackLenghtValue = str2double(get(hObject,'String'));
guidata(hObject, handles);

function fromFrameValue_Callback(hObject, eventdata, handles)
% hObject    handle to fromFrameValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fromFrameValue as text
%        str2double(get(hObject,'String')) returns contents of fromFrameValue as a double
handles.fromFrameValue = str2double(get(hObject,'String'));
guidata(hObject, handles);

function toFrameValue_Callback(hObject, eventdata, handles)
% hObject    handle to toFrameValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of toFrameValue as text
%        str2double(get(hObject,'String')) returns contents of toFrameValue as a double
handles.toFrameValue = str2double(get(hObject,'String'));
guidata(hObject, handles);


function lengthLineValue_Callback(hObject, eventdata, handles)
% hObject    handle to lengthLineValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lengthLineValue as text
%        str2double(get(hObject,'String')) returns contents of lengthLineValue as a double
handles.lengthLineValue = str2double(get(hObject,'String'));
guidata(hObject, handles);



function angleLineValue_Callback(hObject, eventdata, handles)
% hObject    handle to angleLineValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of angleLineValue as text
%        str2double(get(hObject,'String')) returns contents of angleLineValue as a double
handles.angleLineValue = str2double(get(hObject,'String'));
guidata(hObject, handles);

function radiusDiskValue_Callback(hObject, eventdata, handles)
% hObject    handle to radiusDiskValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of radiusDiskValue as text
%        str2double(get(hObject,'String')) returns contents of radiusDiskValue as a double

% --- Executes when selected object is changed in option.
handles.radiusDiskValue = str2double(get(hObject,'String'));
guidata(hObject, handles);

function option_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in option 
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%retrieve GUI data, i.e. the handles structure


% --- Executes on button press in line.
function line_Callback(hObject, eventdata, handles)
% hObject    handle to line (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of line
handles.selectedOption = 'line'; 
guidata(hObject, handles);


% --- Executes on button press in disk.
function disk_Callback(hObject, eventdata, handles)
% hObject    handle to disk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of disk
handles.selectedOption = 'disk'; 
guidata(hObject, handles);


% --- Executes on button press in envelope.
function envelope_Callback(hObject, eventdata, handles)
% hObject    handle to envelope (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of envelope
handles.selectedTechnique = 'envelope'; 
guidata(hObject, handles);


% --- Executes on button press in repicationContours.
function repicationContours_Callback(hObject, eventdata, handles)
% hObject    handle to repicationContours (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of repicationContours
handles.selectedTechnique = 'replicationContours'; 
guidata(hObject, handles);


% --- Executes on button press in play.
function play_Callback(hObject, eventdata, handles)
% hObject    handle to play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
movie(handles.cameraAxes, handles.resultMovie, handles.repetitions, 25);



function repetitionsValue_Callback(hObject, eventdata, handles)
% hObject    handle to repetitionsValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of repetitionsValue as text
%        str2double(get(hObject,'String')) returns contents of repetitionsValue as a double
handles.repetitions = str2double(get(hObject,'String')); 
disp(mat2str(handles.repetitions));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function repetitionsValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repetitionsValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
switch handles.selectedTechnique
    case 'envelope' 
        outputFileName = [handles.VideoName '_Envelope'];
    case 'replicationContours' 
        outputFileName = [handles.VideoName '_ReplicationContours'];
    case 'harris' 
        outputFileName = [handles.VideoName '_Harris']; 
end
saveMovie(handles.resultMovie, [outputFileName '.avi']);
saveImage(handles.resultLastFrame, [outputFileName '_EnvelopeLastFrame.jpg']);


% --- Executes on button press in transparency.
function transparency_Callback(hObject, eventdata, handles)
% hObject    handle to transparency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of transparency
handles.transparencyValue = get(hObject,'Value');
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function transparency_CreateFcn(hObject, eventdata, handles)
% hObject    handle to transparency (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.transparencyValue = 0;
guidata(hObject, handles);


% --- Executes on button press in harris.
function harris_Callback(hObject, eventdata, handles)
% hObject    handle to harris (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of harris
handles.selectedTechnique = 'harris'; 
guidata(hObject, handles);



function samplingRateValue_Callback(hObject, eventdata, handles)
% hObject    handle to samplingRateValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of samplingRateValue as text
%        str2double(get(hObject,'String')) returns contents of samplingRateValue as a double
handles.samplingRateValue = str2double(get(hObject,'String'));
disp(['Rate: ' mat2str(handles.samplingRateValue)]);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function samplingRateValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to samplingRateValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function flickeringFactorValue_Callback(hObject, eventdata, handles)
% hObject    handle to flickeringFactorValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of flickeringFactorValue as text
%        str2double(get(hObject,'String')) returns contents of flickeringFactorValue as a double
handles.flickeringFactorValue = str2double(get(hObject,'String'));
disp(['Fl_Factor: ' mat2str(handles.flickeringFactorValue)]);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function flickeringFactorValue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to flickeringFactorValue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


