%**************************************************************************
% Filename   : replicationOfContours.m
% Description: compute the track of the moving object using the edges
%              of the subject during the movement.
%              The results of the runned script are two:
%	           - an image representing the last frame of the movie with 
%                    the track of the whole movement.
%                  - a movie with, for each frame, the track of the last 
%                    k frames.
% Authors    : Marco Branca, Lorenzo Camerini
%**************************************************************************

%computes the whole track on the last frame
track = edges(:,:,1);
for i = 2:size(edges,3)-1
    track = track + edges(:,:,i);
end

replicationOfContoursLastFrame = computeLastImage(frames(end).cdata, track, separatedBackFore(end).cdata);

if transparencyValue == 0
    transparencyMatrix = ones(size(separatedBackFore(end).cdata));
else
    transparencyMatrix = computeLastImageTransparency(edges, separatedBackFore(end).cdata, 'replicationContours');
end

track = track > 0;

mask = edges;

%add the edges of the previous k frames to all frames
addMaskToMovie;

%saves the results of the computation
%saveMovie(frameWithKTrack, [filename '_ReplicationContours.avi']);
%saveImage(replicationOfContoursLastFrame, [filename '_ReplicationContoursLastFrame.jpg']);

%clears unuseful variables
%clear frameWithKTrack replicationOfContoursLastFrame;
